unit chaines;

interface

uses classes;

{ fonctions de manipulation de chanes }

function islast ( contenu, contenant : string ) : boolean;

function DelEnd ( chaine : string; n : integer ) : string;

function LastChar ( chaine : string ) : char;

function Del ( contenu, contenant : string ) : string;

function IsFirst ( contenu, contenant : string ) : boolean;

function Cut ( chaine : string; d, l : integer ) : string;

function PosRev ( contenu, contenant : string) : integer;

function ExtractWords ( chaine : string ) : TStringList;

function FirstWord ( chaine : string ) : string;

function NthWord ( n : integer; chaine : string ) : string;

implementation

uses SysUtils;

{ fonctions de manipulation de chanes }


const

  basdecasse = 'abcdefghijklmnopqrstuvwxyz';

var
   lettres : string;
   
function islast ( contenu, contenant : string ) : boolean;
begin
   delete ( contenant, 1, length(contenant) - length(contenu) );
   result := contenant = contenu;
end;

function DelEnd ( chaine : string; n : integer ) : string;
begin
   result := copy ( chaine, 1, length(chaine) - n );
end;

function LastChar ( chaine : string ) : char;
begin
   result := chaine [ length(chaine)];
end;

function Del ( contenu, contenant : string ) : string;
   var p, l : integer;
begin
   result := contenant;
   l := length( contenu );
   repeat
      p := pos ( contenu, contenant );
      delete ( contenant, p, l );
      until p = 0;
end;

function IsFirst ( contenu, contenant : string ) : boolean;
begin
   result := pos ( contenu, contenant ) = 1;
end;

function Cut ( chaine : string; d, l : integer ) : string;
begin
   result := chaine;
   delete ( result, d, l );
end;

function PosRev ( contenu, contenant : string) : integer;
// donne la position de la dernire occurrence de contenu dans contenant.
var l : integer;
begin
l := length ( contenant );
result := l - length ( contenu );
  while ( result > 0 ) and ( pos ( copy ( contenant, result, l ), contenant) < 1 )
     do dec ( result );
end;

function ExtractWords ( chaine : string ) : TStringList;
  var mot : string;
      i : integer;
begin
  result := TStringList.Create;
  mot := '';
  for i := 0 to length( chaine ) do
       if pos ( chaine[i], lettres ) > 0 then
            mot := mot + chaine[i]
          else
          begin
            if mot > ''
               then result.Add(mot);
            mot := '';
          end;
end;

function FirstWord ( chaine : string ) : string;
   var i : integer;
begin
  result := '';
  i := 1;
  chaine := trim ( chaine );
  while pos ( chaine[i], lettres ) > 0 do
     begin
        result := result + chaine[i];
        inc ( i );
     end;
end;

function NthWord ( n : integer; chaine : string ) : string;
begin
   while n > 1 do
      begin
         while pos ( chaine[1], lettres) > 0
            do delete ( chaine, 1, 1 );
         chaine := trim ( chaine );
         dec ( n ) ;
      end;
   result := FirstWord ( chaine ) ;
end;

initialization

   lettres := basdeCasse + UpperCase ( basdecasse );

end.
